unit FormDbAdvGridAdvanceTest;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, FireDAC.Phys.MySQLDef, FireDAC.UI.Intf,
  FireDAC.VCLUI.Wait, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.Phys.Intf, FireDAC.Stan.Def, FireDAC.Stan.Pool,
  FireDAC.Stan.Async, FireDAC.Phys
  , Data.DB, FireDAC.Comp.Client, FireDAC.Comp.UI
  , AdvUtil, Vcl.Grids, AdvObj, BaseGrid, AdvGrid,
  DBAdvGrid, Vcl.ExtCtrls, DBAdvGlowNavigator, AdvStyleIF, AdvAppStyler
  , Vcl.StdCtrls
  , AdvOfficeButtons, AdvLabel, FireDAC.Stan.Param, FireDAC.DatS,
  FireDAC.DApt.Intf, FireDAC.DApt, FireDAC.Comp.DataSet, Datasnap.DBClient,
  FireDAC.Stan.StorageBin
  ;

type
  TFormDBADVGRDTEST = class(TForm)
    dsPessoas: TDataSource;
    navMestre: TDBAdvGlowNavigator;
    MyGrid: TDBAdvGrid;
    FormStyler: TAdvFormStyler;
    AdvLabel1: TAdvLabel;
    chkToggleRO: TAdvOfficeCheckBox;
    mtPessoas: TFDMemTable;
    mtPessoasid: TStringField;
    mtPessoasnome: TStringField;
    mtPessoassobrenome: TStringField;
    mtPessoasdatanascimento: TDateField;
    mtPessoasscoring: TShortintField;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure chkToggleROClick(Sender: TObject);
    procedure mtPessoasNewRecord(DataSet: TDataSet);
  private
    procedure SetGridOptions(grd : TDBAdvGrid);
  public
    { Public declarations }
  end;

var
  FormDBADVGRDTEST: TFormDBADVGRDTEST;

implementation

{$R *.dfm}

procedure TFormDBADVGRDTEST.chkToggleROClick(Sender: TObject);
begin
  MyGrid.Columns[MyGrid.ColCount - 1].ReadOnly := chkToggleRO.Checked;
end;

procedure TFormDBADVGRDTEST.FormCreate(Sender: TObject);
begin
  SetGridOptions(MyGrid);
  mtPessoas.Open;
  mtPessoas.AppendRecord(['{39FA1472-4C5F-4A84-AC17-D4EEB4C97877}', 'Joseph', 'Simpson', EncodeDate(1975,1,13), 95]);
  mtPessoas.AppendRecord(['{39FA1472-4C5F-4A84-AC17-D4EEB4C97889}', 'Erico', 'Ruta', EncodeDate(1980,2,20), 74]);
  mtPessoas.AppendRecord(['{39FA1472-7C54-4E23-B14A-D50AF3E016B1}', 'Benjamin', 'Pardal', EncodeDate(1994,6,16), 80]);
  mtPessoas.AppendRecord(['{39FA1475-40BE-4CD1-9C46-F1B26EC8FACE}', 'Paul', 'Folley', EncodeDate(1999,12,16), 60]);
  mtPessoas.AppendRecord(['{39FA147C-90BA-43EF-9259-F028226CD00F}', 'Mark', 'Owen', EncodeDate(1964,6,22), 42]);
end;

procedure TFormDBADVGRDTEST.FormDestroy(Sender: TObject);
begin
  mtPessoas.Close;
end;


procedure TFormDBADVGRDTEST.mtPessoasNewRecord(DataSet: TDataSet);
var
   xguid : tguid;
begin
  if createguid(xguid) = 0 then
    mtPessoas.FieldByName('id').AsString := GUIDToString(xguid)
  else
    // dirty exit only for test purpose
    mtPessoas.FieldByName('id').AsString := random(50000).ToString +random(40000).ToString;

  mtPessoas.FieldByName('scoring').AsInteger := 50;
  mtPessoas.FieldByName('nome').AsString := '';
  mtPessoas.FieldByName('sobrenome').AsString := '';
end;

procedure TFormDBADVGRDTEST.SetGridOptions(grd : TDBAdvGrid);
begin
  with grd do begin
      Cursor := crDefault;
      DrawingStyle := gdsClassic;
      PageMode := true;
      AutoCreateColumns := True;
      AutoRemoveColumns := True;
      DatasetTypeAuto := False;
      DataSetType := dtNonSequenced;
      EditPostMode := epRow;

      with Navigation do begin
        AdvanceAuto := False;
        AdvanceAutoEdit := False;
        AdvanceOnEnter := True;
        AdvanceOnEnterLoop := False;
        AdvanceDirection := adLeftRightInRow;

        AllowCtrlEnter := False;
        AllowClipboardAlways := True;
        AllowClipboardRowGrow := False;
        AllowClipboardColGrow := False;
        AllowInsertRow := true;
        AlwaysEdit := true;
      end;

      Options := Options + [goColSizing];
      Options := Options + [goEditing];
      Options := Options - [goRowSelect, goRangeSelect];

      RefreshOnInsert := True;
      RefreshOnDelete := True;

      ShowBlankRow := false;
      FixedRowAlways := true;

      ScrollBars := ssBoth;
      HoverRowCells := [hcNormal, hcSelected];
      PrintSettings.DateFormat := 'dd/mm/yyyy';
      ShowUnicode := True;
  end;
end;

end.
